﻿using System;
using TSLab.Script;
using TSLab.Script.Handlers;
using TSLab.Script.GraphPane;

namespace Z_QM
{
    [HandlerCategory("ZIP")]
    
    [InputsCount(5)]
    [Input(0, TemplateTypes.BOOL,   Name = "FlagON")]	// Флаг отображения цветовой линии
    [Input(1, TemplateTypes.DOUBLE, Name = "FQMZ")] 	// Флаг количества отображаемый строк
    [Input(2, TemplateTypes.DOUBLE, Name = "StQMax")] 	// Максимальный объем и всех строк стакана указанного направления
    [Input(3, TemplateTypes.DOUBLE, Name = "StPS")]		// Цена строки стакана указанного направления
    [Input(4, TemplateTypes.DOUBLE, Name = "StQS")]		// Объём строки стакана указанного направления
    [OutputsCount(1)]									// В какой цветовой диапозон поподает строка
    [OutputType(TemplateTypes.DOUBLE)]
    
   public class Z_QM : IValuesHandlerWithNumber, IContextUses
    {
   	
   	public IContext Context { set; private get; }
   	
   	[HandlerParameter(true, "0", Min = "0", Max = "49", Step = "1", NotOptimized = true)]
    public int LevelSt { get; set; }
    
    public double Execute( bool FlagON, double FQMZ, double StQMax, double StPS, double StQS, int barNum)
   	{
		var values = new double();
		
		if (!FlagON)
  			return (double) 0;
		
		var Line10 = Math.Round(StQMax/7);
		var Line9 = StQMax;
		var Line8 = Line9-Line10>Line10+1?Line9-Line10:Math.Round(Line9/2);
		var Line7 = Line8-Line10>Line10+1?Line8-Line10:Math.Round(Line8/2);
		var Line6 = Line7-Line10>Line10+1?Line7-Line10:Math.Round(Line7/2);
		var Line5 = Line6-Line10>Line10+1?Line6-Line10:Math.Round(Line6/2);
		var Line4 = Line5-Line10>Line10+1?Line5-Line10:Math.Round(Line5/2);
		var Line3 = Line4-Line10>Line10+1?Line4-Line10:Math.Round(Line4/2);
		var Line2 = Line3-Line10>Line10+1?Line3-Line10:Math.Round(Line3/2);
		var Line1 = Line2-Line10>Line10+1?Line2-Line10:Math.Round(Line2/2);
		
//		if (Line1>=StQS && StQS<Line2 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+1; return values;}
//		if (Line2>=StQS && StQS>Line1 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+2; return values;}
//		if (Line3>=StQS && StQS>Line2 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+3; return values;}
//		if (Line4>=StQS && StQS>Line3 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+4; return values;}
//		if (Line5>=StQS && StQS>Line4 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+5; return values;}
//		if (Line6>=StQS && StQS>Line5 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+6; return values;}
//		if (Line7>=StQS && StQS>Line6 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+7; return values;}
//		if (Line8>=StQS && StQS>Line7 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+8; return values;}
//		if (Line9+1>=StQS && StQS>Line8 && StQS!=0 && FQMZ >= LevelSt) { values = StPS*10+9; return values;}
		
		if (Line1>=StQS && StQS<Line2 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.1; return values;}
		if (Line2>=StQS && StQS>Line1 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.2; return values;}
		if (Line3>=StQS && StQS>Line2 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.3; return values;}
		if (Line4>=StQS && StQS>Line3 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.4; return values;}
		if (Line5>=StQS && StQS>Line4 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.5; return values;}
		if (Line6>=StQS && StQS>Line5 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.6; return values;}
		if (Line7>=StQS && StQS>Line6 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.7; return values;}
		if (Line8>=StQS && StQS>Line7 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.8; return values;}
		if (Line9+1>=StQS && StQS>Line8 && StQS!=0 && FQMZ >= LevelSt) { values = StPS+0.9; return values;}
		    
        return values;
        }
    }
}
